//demo program for Fig. 8.48: the rotating cube with texture on each face. 
//Non-interactive. Hill/Kelley, 3e, July 2006
//to see top face change glTranslated() - y argument up or down

#include "GL/glut.h"
#include "RGBpixmap.h"
#include <math.h>

#define GL_MIRRORED_REPEAT 0x8370

//######################## GLOBALS ########################
RGBpixmap pix[6];    // make six (empty) pixmaps
float xSpeed = 0.01, ySpeed = 0.05,  xAngle = 0.02, yAngle = 0.02, zAngle = 0.02;
//<<<<<<<<<<<<<<<<<<<<<<<<<<< myinit >>>>>>>>>>>>>>>>>>>>>>>>>>>.
void myInit(void)
{	
	glClearColor(1.0f,1.0f,1.0f,1.0f);  // background is white 
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_TEXTURE_2D);

	pix[0].makeCheckerboard();        	// make pixmap procedurally 
	pix[0].setTexture(2001);              	// create texture

	pix[1].readBMPFile("mandrill.bmp");  // make pixmap from image
	pix[1].setTexture(2002);		// create texture

	pix[2].readBMPFile("sun.bmp");  // make pixmap from image
	pix[2].setTexture(2003);		// create texture

	pix[3].readBMPFile("earth.bmp");  // make pixmap from image
	pix[3].setTexture(2004);		// create texture

	pix[4].readBMPFile("moon.bmp");  // make pixmap from image
	pix[4].setTexture(2005);		// create texture

	pix[5].readBMPFile("draw.bmp");  // make pixmap from image
	pix[5].setTexture(2006);		// create texture



	//glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_MIRRORED_REPEAT);
	//glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_MIRRORED_REPEAT);
	//glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	//glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);


	glViewport(0, 0, 640, 480); // set up the viewing system
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(60.0, 640.0/ 480, 1.0, 30.0); // set camera shape
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glTranslated(0.0, -0.2, -4); // move camera back
}
//<<<<<<<<<<<<<<<<<<<<<<<<<<< display >>>>>>>>>>>>>>>>>>>>>>
void display(void)
{
  	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
	glPushMatrix();
	glRotated(xAngle, 1.0,0.0,0.0);
	glRotated(yAngle, 0.0,1.0,0.0);
	glRotated(zAngle, 0.0,0.0,1.0);
		
	glBindTexture(GL_TEXTURE_2D,2001); 	// top face:  checkerboard
	glBegin(GL_QUADS);
	glTexCoord2f(0.0, 0.0); glVertex3f(-1.0f, 1.0f, -1.0f);
	glTexCoord2f(1.0, 0.0); glVertex3f(-1.0f, 1.0f,  1.0f);
	glTexCoord2f(1.0, 1.0); glVertex3f( 1.0f, 1.0f,  1.0f);
	glTexCoord2f(0.0, 1.0); glVertex3f( 1.0f, 1.0f, -1.0f);
	glEnd();

	glBindTexture(GL_TEXTURE_2D,2004); 	// right face: mandrill
	glBegin(GL_QUADS);
	glTexCoord2f(0.0, 0.0); glVertex3f(1.0f, -1.0f,  1.0f);
	glTexCoord2f(1.0, 0.0); glVertex3f(1.0f, -1.0f, -1.0f);
	glTexCoord2f(1.0, 1.0); glVertex3f(1.0f,  1.0f, -1.0f);
	glTexCoord2f(0.0, 1.0); glVertex3f(1.0f,  1.0f,  1.0f);
	glEnd();

	glBindTexture(GL_TEXTURE_2D,2003); 	// left face: sun
	glBegin(GL_QUADS);
	glTexCoord2f(0.0, 0.0); glVertex3f(-1.0f, 1.0f,  -1.0f);
	glTexCoord2f(1.0, 0.0); glVertex3f(-1.0f, 1.0f, 1.0f);
	glTexCoord2f(1.0, 1.0); glVertex3f(-1.0f, -1.0f, 1.0f);
	glTexCoord2f(0.0, 1.0); glVertex3f(-1.0f,  -1.0f,  -1.0f);
	glEnd();

	glBindTexture(GL_TEXTURE_2D,2004);  // earth
	glBegin(GL_QUADS);
	glTexCoord2f(0.0, 0.0); glVertex3f(1.0f, -1.0f, 1.0f);
	glTexCoord2f(1.0, 0.0); glVertex3f(-1.0f, -1.0f, 1.0f);
	glTexCoord2f(1.0, 1.0); glVertex3f(-1.0f, -1.0f,  -1.0f);
	glTexCoord2f(0.0, 1.0); glVertex3f(1.0f, -1.0f,  -1.0f);
	glEnd();

	glBindTexture(GL_TEXTURE_2D,2005); 	// box front: moon
	glBegin(GL_QUADS);
	glTexCoord2f(0.0, 0.0); glVertex3f(1.0f, 1.0f, 1.0f);
	glTexCoord2f(1.0, 0.0); glVertex3f(1.0f, -1.0f, 1.0f);
	glTexCoord2f(1.0, 1.0); glVertex3f(-1.0f, -1.0f, 1.0f);
	glTexCoord2f(0.0, 1.0); glVertex3f(-1.0f, 1.0f, 1.0f);
	glEnd();

	glBindTexture(GL_TEXTURE_2D,2006); 	// box back  red
	glBegin(GL_QUADS);
	glTexCoord2f(0.0, 0.0); glVertex3f(-1.0f, 1.0f, -1.0f);
	glTexCoord2f(2.0, 0.0); glVertex3f(1.0f, 1.0f, -1.0f);
	glTexCoord2f(2.0, 2.0); glVertex3f(1.0f, -1.0f, -1.0f);
	glTexCoord2f(0.0, 2.0); glVertex3f(-1.0f, -1.0f, -1.0f);
	glEnd();



//	// cylinder texture mapping
//	GLfloat t, dt, PI = 3.1415926;
//	int i, j, nslice = 36;
//	glBindTexture(GL_TEXTURE_2D,2006);
//	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
//	glBegin( GL_QUAD_STRIP);
//	     t = 0.;  dt = 2*PI/nslice;
//	     for (j = 0; j <= nslice; ++j) {
//	          glTexCoord2f( 2.0*t/(2*PI), 1.);  glVertex3f( cos( t), 2., -sin( t));
//	          glTexCoord2f( 2.0*t/(2*PI), 0.);  glVertex3f( cos( t), 0., -sin( t));
//	          t = t + dt;
//	     }
//	glEnd();


	glFlush();
	glPopMatrix();
	glutSwapBuffers();
	glutPostRedisplay();
}
//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< spinner >>>>>>>>>>>>>>>>>>>>>
void spinner(void)
{ // alter angles by small amount
	xAngle += xSpeed;  yAngle += ySpeed;
	display();
} 
//<<<<<<<<<<<<<<<<<<<<<< main >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
int main(int argc, char **argv)
{
	glutInit(&argc, argv);          // initialize the toolkit
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB); // set the display mode
	glutInitWindowSize(600, 800);     // set the window size
	glutInitWindowPosition(100, 150); // set the window position on the screen
	glutCreateWindow("Rotating Cube Demo"); // open the screen window(with its exciting title)
	glutDisplayFunc(display);     // register the redraw function
	myInit();                   
	glutIdleFunc(spinner);
	glutMainLoop(); 		     // go into a perpetual loop
	return 0;
} 
